tests: move the check of exec.skip to detect compilation error
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export LC_ALL=C
23 export NIT_TESTING=true
24 export MNIT_SRAND=0
25
26 unset NIT_DIR
27
28 # Get the first Java lib available
29 shopt -s nullglob
30 paths=`echo /usr/lib/jvm/*/`
31 paths=($paths)
32 JAVA_HOME=${paths[0]}
33
34 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
35 paths=($paths)
36 JNI_LIB_PATH=${paths[0]}
37 shopt -u nullglob
38
39 usage()
40 {
41 e=`basename "$0"`
42 cat<<END
43 Usage: $e [options] modulenames
44 -o option Pass option to the engine
45 -v Verbose (show tests steps)
46 -h This help
47 --engine Use a specific engine (default=nitg)
48 --noskip Do not skip a test even if the .skip file matches
49 END
50 }
51
52 # $1 is the pattern of the test
53 # $2 is the file to compare to
54 # the result is:
55 # 0: if the file to compare to do not exists
56 # 1: if the file match
57 # 2: if the file match with soso
58 # 3: if the file do not match
59 function compare_to_result()
60 {
61 local pattern="$1"
62 local sav="$2"
63 if [ ! -r "$sav" ]; then return 0; fi
64 test "`cat "$sav"`" = "UNDEFINED" && return 1
65 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
66 if [ "$?" == 0 ]; then
67 return 1
68 fi
69 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
70 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
71 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
72 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
73 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log2"
74 if [ "$?" == 0 ]; then
75 return 2
76 else
77 return 3
78 fi
79 }
80
81 # As argument: the pattern used for the file
82 function process_result()
83 {
84 # Result
85 pattern=$1
86 description=$2
87 pack=$3
88 SAV=""
89 NSAV=""
90 FIXME=""
91 NFIXME=""
92 SOSO=""
93 NSOSO=""
94 SOSOF=""
95 NSOSOF=""
96 OLD=""
97 LIST=""
98 FIRST=""
99 echo >>$xml "<testcase classname='$pack' name='$description'>"
100 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
101 for savdir in $savdirs; do
102 sav=$savdir/fixme/$pattern.res
103 compare_to_result "$pattern" "$sav"
104 case "$?" in
105 0)
106 ;; # no file
107 1)
108 OLD="$LIST"
109 FIXME="$sav"
110 LIST="$LIST $sav"
111 ;;
112 2)
113 if [ -z "$FIRST" ]; then
114 SOSOF="$sav"
115 FIRST="$sav"
116 fi
117 LIST="$LIST $sav"
118 ;;
119 3)
120 if [ -z "$FIRST" ]; then
121 NFIXME="$sav"
122 FIRST="$sav"
123 fi
124 LIST="$LIST $sav"
125 ;;
126 esac
127
128 sav=$savdir/$pattern.res
129 compare_to_result "$pattern" "$sav"
130 case "$?" in
131 0)
132 ;; # no file
133 1)
134 OLD="$LIST"
135 SAV="$sav"
136 LIST="$LIST $sav"
137 ;;
138 2)
139 if [ -z "$FIRST" ]; then
140 SOSO="$sav"
141 FIRST="$sav"
142 fi
143 LIST="$LIST $sav"
144 ;;
145 3)
146 if [ -z "$FIRST" ]; then
147 NSAV="$sav"
148 FIRST="$sav"
149 fi
150 LIST="$LIST $sav"
151 ;;
152 esac
153 done
154 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
155 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
156 NYI="$?"
157 if [ -n "$SAV" ]; then
158 if [ -n "$OLD" ]; then
159 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
160 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
161 remains="$remains $OLD"
162 else
163 echo "[ok] out/$pattern.res $SAV"
164 fi
165 ok="$ok $pattern"
166 elif [ -n "$FIXME" ]; then
167 if [ -n "$OLD" ]; then
168 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
169 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
170 remains="$remains $OLD"
171 else
172 echo "[fixme] out/$pattern.res $FIXME"
173 echo >>$xml "<skipped/>"
174 fi
175 todos="$todos $pattern"
176 elif [ "x$NYI" = "x0" ]; then
177 echo "[todo] out/$pattern.res -> not yet implemented"
178 echo >>$xml "<skipped/>"
179 todos="$todos $pattern"
180 elif [ -n "$SOSO" ]; then
181 echo "[======= soso out/$pattern.res $SOSO =======]"
182 echo >>$xml "<error message='soso out/$pattern.res $SOSO'/>"
183 echo >>$xml "<system-out><![CDATA["
184 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
185 echo >>$xml "]]></system-out>"
186 nok="$nok $pattern"
187 echo "$ii" >> "$ERRLIST"
188 elif [ -n "$SOSOF" ]; then
189 echo "[======= fixme soso out/$pattern.res $SOSOF =======]"
190 echo >>$xml "<error message='soso out/$pattern.res $SOSO'/>"
191 echo >>$xml "<system-out><![CDATA["
192 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
193 echo >>$xml "]]></system-out>"
194 nok="$nok $pattern"
195 echo "$ii" >> "$ERRLIST"
196 elif [ -n "$NSAV" ]; then
197 echo "[======= fail out/$pattern.res $NSAV =======]"
198 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
199 echo >>$xml "<system-out><![CDATA["
200 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
201 echo >>$xml "]]></system-out>"
202 nok="$nok $pattern"
203 echo "$ii" >> "$ERRLIST"
204 elif [ -n "$NFIXME" ]; then
205 echo "[======= changed out/$pattern.res $NFIXME ======]"
206 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
207 echo >>$xml "<system-out><![CDATA["
208 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
209 echo >>$xml "]]></system-out>"
210 nok="$nok $pattern"
211 echo "$ii" >> "$ERRLIST"
212 elif [ -s out/$pattern.res ]; then
213 echo "[=== no sav ===] out/$pattern.res is not empty"
214 echo >>$xml "<error message='no sav and not empty'/>"
215 echo >>$xml "<system-out><![CDATA["
216 cat -v >>$xml out/$pattern.res
217 echo >>$xml "]]></system-out>"
218 nos="$nos $pattern"
219 else
220 # no sav but empty res
221 echo "[0k] out/$pattern.res is empty"
222 ok="$ok $pattern"
223 fi
224 if test -s out/$pattern.cmp.err; then
225 echo >>$xml "<system-err><![CDATA["
226 cat -v >>$xml out/$pattern.cmp.err
227 echo >>$xml "]]></system-err>"
228 fi
229 echo >>$xml "</testcase>"
230 }
231
232 need_skip()
233 {
234 test "$noskip" = true && return 1
235 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
236 echo "=> $2: [skip]"
237 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
238 return 0
239 fi
240 if test $engine = niti && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
241 echo "=> $2: [skip exec]"
242 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
243 return 0
244 fi
245 return 1
246 }
247
248 skip_exec()
249 {
250 test "$noskip" = true && return 1
251 if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
252 echo -n "_ "
253 return 0
254 fi
255 return 1
256 }
257
258 skip_cc()
259 {
260 test "$noskip" = true && return 1
261 if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
262 return 0
263 fi
264 return 1
265 }
266
267 find_nitc()
268 {
269 name="$enginebinname"
270 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
271 if [[ "x$recent" == "x" ]]; then
272 echo "Could not find binary for engine $engine, aborting"
273 exit 1
274 fi
275 echo "Find binary for engine $engine: $recent $OPT"
276 NITC=$recent
277 }
278
279 verbose=false
280 stop=false
281 engine=nitg
282 noskip=
283 savdirs=
284 while [ $stop = false ]; do
285 case $1 in
286 -o) OPT="$OPT $2"; shift; shift;;
287 -v) verbose=true; shift;;
288 -h) usage; exit;;
289 --engine) engine="$2"; shift; shift;;
290 --noskip) noskip=true; shift;;
291 *) stop=true
292 esac
293 done
294 enginebinname=$engine
295 case $engine in
296 nitg)
297 engine=nitg-s;
298 enginebinname=nitg;
299 OPT="--separate $OPT"
300 ;;
301 nitg-s)
302 enginebinname=nitg;
303 OPT="--separate $OPT"
304 ;;
305 nitg-e)
306 enginebinname=nitg;
307 OPT="--erasure $OPT"
308 ;;
309 nitg-sg)
310 enginebinname=nitg;
311 OPT="--semi-global $OPT"
312 ;;
313 nitg-g)
314 enginebinname=nitg;
315 OPT="--global $OPT"
316 ;;
317 nit)
318 engine=niti
319 ;;
320 niti)
321 enginebinname=nit
322 ;;
323 emscripten)
324 enginebinname=nitg
325 OPT="-m emscripten_nodejs.nit --semi-global $OPT"
326 savdirs="sav/nitg-sg/"
327 ;;
328 nitc)
329 echo "disabled engine $engine"
330 exit 0
331 ;;
332 *)
333 echo "unknown engine $engine"
334 exit 1
335 ;;
336 esac
337
338 savdirs="sav/$engine $savdirs sav/"
339
340 # The default nitc compiler
341 [ -z "$NITC" ] && find_nitc
342
343 # Set NIT_DIR if needed
344 [ -z "$NIT_DIR" ] && export NIT_DIR=..
345
346 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
347 TIMEOUT="timelimit -t 600"
348 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
349 TIMEOUT="timeout 600s"
350 else
351 echo "No timelimit or timeout command detected. Tests may hang :("
352 fi
353
354 # Mark to distinguish files among tests
355 # MARK=
356
357 # File where error tests are outputed
358 # Old ERRLIST is backuped
359 ERRLIST=${ERRLIST:-errlist}
360 ERRLIST_TARGET=$ERRLIST
361
362 if [ $# = 0 ]; then
363 usage;
364 exit
365 fi
366
367 # Initiate new ERRLIST
368 if [ "x$ERRLIST" = "x" ]; then
369 ERRLIST=/dev=null
370 else
371 ERRLIST=$ERRLIST.tmp
372 > "$ERRLIST"
373 fi
374
375 ok=""
376 nok=""
377 todos=""
378 xml="tests-$engine.xml"
379 echo >$xml "<testsuites><testsuite>"
380
381 # CLEAN the out directory
382 rm -rf out/ 2>/dev/null
383 mkdir out 2>/dev/null
384
385 for ii in "$@"; do
386 if [ ! -f $ii ]; then
387 echo "File '$ii' does not exist."
388 continue
389 fi
390 f=`basename "$ii" .nit`
391
392 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
393
394 # Sould we skip the file for this engine?
395 need_skip $f $f $pack && continue
396
397 tmp=${ii/../AA}
398 if [ "x$tmp" = "x$ii" ]; then
399 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
400 else
401 includes="-I alt"
402 fi
403
404 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
405 bf=`basename $i .nit`
406 ff="out/$bf"
407
408 # Sould we skip the alternative for this engine?
409 need_skip $bf $bf $pack && continue
410
411 echo -n "=> $bf: "
412
413 if [ -f "$f.inputs" ]; then
414 inputs="$f.inputs"
415 export MNIT_READ_INPUT="$f.inputs"
416 else
417 inputs=/dev/null
418 export MNIT_READ_INPUT=/dev/null
419 fi
420
421 ffout="$ff.bin"
422 if [ "$engine" = "emscripten" ]; then
423 ffout="$ff.bin.js"
424 fi
425
426 if [ "$engine" = "niti" ]; then
427 cat > "./$ff.bin" <<END
428 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
429 END
430 chmod +x "./$ff.bin"
431 > "$ff.cmp.err"
432 > "$ff.compile.log"
433 ERR=0
434 else
435 if skip_cc "$bf"; then
436 nocc="--no-cc"
437 else
438 nocc=
439 fi
440 # Compile
441 if [ "x$verbose" = "xtrue" ]; then
442 echo ""
443 echo $NITC --no-color $OPT -o "$ffout" "$i" "$includes" $nocc
444 fi
445 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
446 $TIMEOUT $NITC --no-color $OPT -o "$ffout" "$i" $includes $nocc 2> "$ff.cmp.err" > "$ff.compile.log"
447 ERR=$?
448 if [ "x$verbose" = "xtrue" ]; then
449 cat "$ff.compile.log"
450 cat >&2 "$ff.cmp.err"
451 fi
452 fi
453 if [ "$engine" = "emscripten" ]; then
454 echo > "./$ff.bin" "nodejs $ffout \"\$@\""
455 chmod +x "$ff.bin"
456 if grep "Fatal Error: more than one primitive class" "$ff.compile.log" > /dev/null; then
457 echo " [skip] do no not imports kernel"
458 echo >>$xml "<testcase classname='$pack' name='$bf'><skipped/></testcase>"
459 continue
460 fi
461 fi
462 if [ "$ERR" != 0 ]; then
463 echo -n "! "
464 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
465 process_result $bf $bf $pack
466 elif [ -n "$nocc" ]; then
467 # not compiled
468 echo -n "nocc "
469 > "$ff.res"
470 process_result $bf $bf $pack
471 elif [ -x "./$ff.bin" ]; then
472 if skip_exec "$bf"; then
473 # No exec
474 > "$ff.res"
475 process_result $bf $bf $pack
476 break
477 fi
478 echo -n ". "
479 # Execute
480 args=""
481 if [ "x$verbose" = "xtrue" ]; then
482 echo ""
483 echo "NIT_NO_STACK=1 ./$ff.bin" $args
484 fi
485 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
486 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
487 if [ "x$verbose" = "xtrue" ]; then
488 cat "$ff.res"
489 cat >&2 "$ff.err"
490 fi
491 if [ -f "$ff.write" ]; then
492 cat "$ff.write" >> "$ff.res"
493 elif [ -d "$ff.write" ]; then
494 LANG=C /bin/ls -F $ff.write >> "$ff.res"
495 fi
496 cp "$ff.res" "$ff.res2"
497 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
498 process_result $bf $bf $pack
499
500 if [ -f "$f.args" ]; then
501 fargs=$f.args
502 cptr=0
503 while read line; do
504 ((cptr=cptr+1))
505 args="$line"
506 bff=$bf"_args"$cptr
507 fff=$ff"_args"$cptr
508 name="$bf args $cptr"
509
510 # Sould we skip the input for this engine?
511 need_skip $bff " $name" $pack && continue
512
513 # use a specific inputs file, if required
514 if [ -f "$bff.inputs" ]; then
515 ffinputs="$bff.inputs"
516 else
517 ffinputs=$inputs
518 fi
519
520 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
521 if [ "x$verbose" = "xtrue" ]; then
522 echo ""
523 echo "NIT_NO_STACK=1 ./$ff.bin" $args
524 fi
525 echo -n "==> $name "
526 echo "./$ff.bin $args" > "./$fff.bin"
527 chmod +x "./$fff.bin"
528 WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
529 if [ "x$verbose" = "xtrue" ]; then
530 cat "$fff.res"
531 cat >&2 "$fff.err"
532 fi
533 if [ -f "$fff.write" ]; then
534 cat "$fff.write" >> "$fff.res"
535 elif [ -d "$fff.write" ]; then
536 LANG=C /bin/ls -F $fff.write >> "$fff.res"
537 fi
538 if [ -s "$fff.err" ]; then
539 cp "$fff.res" "$fff.res2"
540 cat "$fff.err" "$fff.res2" > "$fff.res"
541 fi
542 process_result $bff " $name" $pack
543 done < $fargs
544 fi
545 elif [ -f "./$ff.bin" ]; then
546 echo "Not executable (platform?)" > "$ff.res"
547 process_result $bf "$bf" $pack
548 else
549 echo -n "! "
550 cat "$ff.cmp.err" > "$ff.res"
551 echo "Compilation error" > "$ff.res"
552 process_result $bf "$bf" $pack
553 fi
554 done
555 done
556
557 echo "engine: $engine ($enginebinname $OPT)"
558 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
559
560 if [ -n "$nok" ]; then
561 echo "fail: $nok"
562 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
563 fi
564 if [ -n "$nos" ]; then
565 echo "no sav: $nos"
566 fi
567 if [ -n "$todos" ]; then
568 echo "todo/fixme: $todos"
569 fi
570 if [ -n "$remains" ]; then
571 echo "sav that remains: $remains"
572 fi
573
574 # write $ERRLIST
575 if [ "x$ERRLIST" != "x" ]; then
576 if [ -x "$ERRLIST_TARGET" ]; then
577 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
578 fi
579 mv $ERRLIST $ERRLIST_TARGET
580 fi
581
582 echo >>$xml "</testsuite></testsuites>"
583
584 if [ -n "$nok" ]; then
585 exit 1
586 else
587 exit 0
588 fi